package dev.shadowsoffire.apotheosis.adventure.affix.effect;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.adventure.AdventureConfig;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import dev.shadowsoffire.placebo.util.StepFunction;
import java.util.Map;
import java.util.function.Function;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.context.UseOnContext;

public class EnlightenedAffix extends Affix {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.affix.effect.EnlightenedAffix> CODEC;
  
  protected final Map<LootRarity, StepFunction> values;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)GemBonus.VALUES_CODEC.fieldOf("values").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.affix.effect.EnlightenedAffix::new));
  }
  
  public EnlightenedAffix(Map<LootRarity, StepFunction> values) {
    super(AffixType.ABILITY);
    this.values = values;
  }
  
  public boolean canApplyTo(ItemStack stack, LootCategory cat, LootRarity rarity) {
    return (cat.isBreaker() && this.values.containsKey(rarity));
  }
  
  public MutableComponent getDescription(ItemStack stack, LootRarity rarity, float level) {
    return Component.m_237110_("affix." + getId() + ".desc", new Object[] { Integer.valueOf(getTrueLevel(rarity, level)) });
  }
  
  public Component getAugmentingText(ItemStack stack, LootRarity rarity, float level) {
    MutableComponent comp = getDescription(stack, rarity, level);
    MutableComponent mutableComponent1 = Component.m_237113_(fmt(getTrueLevel(rarity, 0.0F)));
    MutableComponent mutableComponent2 = Component.m_237113_(fmt(getTrueLevel(rarity, 1.0F)));
    return (Component)comp.m_7220_((Component)valueBounds((Component)mutableComponent1, (Component)mutableComponent2));
  }
  
  public InteractionResult onItemUse(ItemStack stack, LootRarity rarity, float level, UseOnContext ctx) {
    Player player = ctx.m_43723_();
    if (((Item)AdventureConfig.torchItem.get()).m_6225_(ctx).m_19077_()) {
      if (ctx.m_43722_().m_41619_())
        ctx.m_43722_().m_41769_(1); 
      player.m_21120_(ctx.m_43724_()).m_41622_(((StepFunction)this.values.get(rarity)).getInt(level), (LivingEntity)player, p -> p.m_21190_(ctx.m_43724_()));
      return InteractionResult.SUCCESS;
    } 
    return super.onItemUse(stack, rarity, level, ctx);
  }
  
  public Codec<? extends Affix> getCodec() {
    return (Codec)CODEC;
  }
  
  protected int getTrueLevel(LootRarity rarity, float level) {
    return ((StepFunction)this.values.get(rarity)).getInt(level);
  }
}
